from tensorflow.keras import Model
import tensorflow as tf

class ConcreteDropoutModel(Model):

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.nDropoutSamples = 10

    def predict(self,X):
        preds = tf.stack([model(X,training=True) for _ in range(self.nDropoutSamples) for model in self.models],axis=0)
        mean = tf.math.reduce_mean(preds,axis=0)
        std  = tf.math.reduce_std(preds,axis=0)
        return mean,std        

    @classmethod
    def load(cls, rootDir,predictFun=None,custom_objects=None):
        num_models=8
        return super.load(num_models)