import tensorflow as tf
import numpy as np

def Gaussian_NLL_Loss(true,pred):
    # nb sigma is stdev, sigma^2 is variance
    true, sigma = tf.split(true,2,axis=-1)
    pred, sigma = tf.split(pred,2,axis=-1)
    eps = 0 #1e-7
    logprob = -tf.math.log(sigma**2+eps) - 0.5*tf.math.log(2*np.pi) - 0.5*((true-pred)/sigma)**2
    loss = tf.reduce_mean(-logprob)
    #print(true.shape)
    #print(pred.shape)
    #print("done\n")
    return loss


"""
import tensorflow as tf
import importlib
import loss_functions
importlib.reload(loss_functions)
y_true = tf.constant([[1.0,2.0],[0.01,3.0]])
pred = tf.constant([[1.0,2.0],[-0.01,3.0]])
l = loss_functions.hellinger_loss(y_true,pred)

y_true = tf.constant([[1.0,2.0],[0.01,3.0]])
pred = tf.constant([[1.0,2.0],[0.005,3.0]])
l = loss_functions.hellinger_loss(y_true,pred)

"""
def hellinger_loss(y_true,pred):
    # first find largest negative prediction and add it to all the data to avoid NaN or complex results
    pred_negs = tf.where(pred < 0.0, pred, 0.0) # find smallest negative prediction. If none are found, return zero.
    largest_neg = tf.reduce_min(pred_negs)
    #tf.print((largest_neg))
    #pred_pos = tf.where(pred < 0,0.0,pred) # pred_pos is pred when pred is >= 0, and 0 otherwise.
    pred_shifted = tf.subtract(pred,largest_neg)
    true_shifted = tf.subtract(y_true,largest_neg)
    #tf.print((pred_shifted))
    #tf.print((true_shifted))
    # NB don't include 1/sqrt(2) in front as it's a constant
    #return tf.sqrt(tf.reduce_sum(tf.square(tf.sqrt(pred_pos) - tf.sqrt(y_true))))
    #return tf.sqrt(tf.reduce_sum(tf.square(tf.sqrt(pred_shifted) - tf.sqrt(true_shifted))))
    return tf.sqrt(
        tf.reduce_sum(
            tf.square(tf.sqrt(tf.cast(pred,tf.float32)) - tf.sqrt(tf.cast(y_true,tf.float32)))
            )
            )