import openmc
import numpy as np

def meshTally(name, pitch,Ngroups,resolution):
    mesh = openmc.RegularMesh()
    mesh.dimension = resolution #indices in each direction
    mesh.lower_left = [-pitch/2, -pitch/2] #indices in each direction
    mesh.upper_right = [pitch/2, pitch/2] #indices in each direction
    #mesh.width = [pitch, pitch]
    groups = np.logspace(np.log10(1.0e-5), np.log10(20.0e6),Ngroups+1)
    energyFilter = openmc.EnergyFilter(groups)
    #energyFilter = openmc.EnergyFilter([1.0e5, 20.0e6])
    tally = openmc.Tally(name=name)
    tally.filters = [energyFilter,openmc.MeshFilter(mesh)]
    tally.scores = ['flux']
    #tally.estimator = 'tracklength'
    return tally