from .context import src
import src.make_samples as ms
import numpy as np

def test_simple_random():
    dataFrame = ms.simpleRandom(1,seed=999)
    assert dataFrame['fuel_radius'][0] == 0.39218
    assert dataFrame['assembly_materials'][0][0][0] == 'Borated Water'
    assert dataFrame['assembly_materials'][0][0][-1] == 'Fuel 1.6%'
    assert dataFrame['assembly_materials'][0][-1][-1] == 'Fuel 3.4%'
    assert dataFrame['assembly_materials'][0][-1][0] == 'Fuel 1.6%'

def test_simple_random_assign_radii():
    dataFrame=ms.simpleRandomAssignRadii(1,seed=999, radii=[999,0,0])
    assert dataFrame['assembly_materials'][0][0][0] == 'Borated Water'
    assert dataFrame['assembly_materials'][0][0][-1] == 'Fuel 1.6%'
    assert dataFrame['assembly_materials'][0][-1][-1] == 'Fuel 3.4%'
    assert dataFrame['assembly_materials'][0][-1][0] == 'Fuel 1.6%'
    assert dataFrame['fuel_radius'][0][0][0]==999
    assert dataFrame['fuel_radius'][0][0][-1]==0
    assert dataFrame['fuel_radius'][0][-1][-1]==0
    assert dataFrame['fuel_radius'][0][-1][0]==0

def test_random_sweep_multiparameter():
    dataFrame_01=ms.random_sweep_multiparameter(1,seed=999)
    assert dataFrame_01['assembly_materials'].iloc[0][0][0] == 'Fuel 3.2%'
    # test that using the same seed gives you the same result
    dataFrame_02=ms.random_sweep_multiparameter(1,seed=999)
    assert np.all(dataFrame_01['fuel_radius'].iloc[0] == dataFrame_02['fuel_radius'].iloc[0])
    # test that using a different seed gives you a different result
    dataFrame_03=ms.random_sweep_multiparameter(1,seed=998)
    assert np.any(dataFrame_01['fuel_radius'].iloc[0] != dataFrame_03['fuel_radius'].iloc[0])
    