from .context import src
import src.make_samples as ms
import src.OpenMCWrapper as OpenMCWrapper
import src.BeavrsAssemblyOpenMCWrapper as BeavrsAssemblyOpenMCWrapper

def test_simple_model_generation_01():
    dataFrame = ms.simpleRandom(1,999)
    wrapper = OpenMCWrapper(dataFrame,15,30,[32,32],[128,128])
    model = wrapper.generateModel(0)
    #tally = wrapper.generateTally(model, wrapper.loFiName, wrapper.NgroupsIn, wrapper.resolutionIn)
    allCells = model.geometry.get_all_cells()
    allMaterials = model.geometry.get_all_materials()
    assert len(allCells.keys()) == 868
    assert len(allMaterials.keys()) == 9
    materialNames = [material.name for (key,material) in allMaterials.items()]
    assert materialNames == ['Borated Water', 'Cladding', 'Hot borated water', 'Fuel 3.1%', 'Fuel 3.2%', 'B4C', 'Fuel 2.4%', 'Fuel 1.6%', 'Fuel 3.4%']

def test_BEAVRS_model_generation_01():
    dataFrame = ms.BEAVRS_assemblies()
    wrapper = BeavrsAssemblyOpenMCWrapper(dataFrame,15,30,[32,32],[128,128])
    model = wrapper.generateModel(0)
    #tally = wrapper.generateTally(model, wrapper.loFiName, wrapper.NgroupsIn, wrapper.resolutionIn)
    allCells = model.geometry.get_all_cells()
    allMaterials = model.geometry.get_all_materials()
    assert len(allCells.keys()) == 63
    assert len(allMaterials.keys()) == 7
    materialNames = [material.name for (key,material) in allMaterials.items()]
    assert materialNames == ['Borated Water', 'SS SPN', 'Zircaloy 4', 'Fuel 3.1%', 'Helium', 'Inconel 718', 'Water SPN']